// подключение библиотеки
#include<AccelStepper.h>
 
#define HALFSTEP 8   
// Инициализируемся с последовательностью выводов IN1-IN3-IN2-IN4 
// для использования AccelStepper с 28BYJ-48
AccelStepper stepper1(HALFSTEP, 8, 10, 9, 11);

// клавиши выбора режима
int pinButtons[]={5,6,7};
int lastButtons[]={0,0,0};
int currentButtons[]={0,0,0};
//
boolean go=false;

void setup(){
   Serial.begin(9600);
  stepper1.setMaxSpeed(1000.0);
  stepper1.setAcceleration(100.0);
  stepper1.setSpeed(-500);
}

void loop() {
  // проверка нажатия кнопок выбора программ
  for(int i=0;i<3;i++) {
     currentButtons[i] = debounce(lastButtons[i],pinButtons[i]);
     // если нажатие...
     if (lastButtons[i] == 0 && currentButtons[i] == 1) {
        switch(i) {
           case 0:   // против часовой
                 stepper1.setSpeed(500);
                 go=true;
                 Serial.println("CW");
              break;     
           case 1:   // стоп
                 stepper1.stop();
                 go=false;
                 Serial.println("stop");
              break;     
           case 2:   // по часовой
                 stepper1.setSpeed(-500);
                 go=true;
                 Serial.println("CCW");
              break;     
           default:   
              break; 
        }    
     }    
     lastButtons[i] = currentButtons[i]; 
  } 
  if(go==true)              
     stepper1.runSpeed();                             

}
 
// Функция сглаживания дребезга
int debounce(int last,int pin1){
  int current = digitalRead(pin1);   // Считать состояние кнопки
  if (last != current)                     // если изменилось...
    {
    delay(5);                              // ждем 5мс
    current = digitalRead(pin1);         // считываем состояние кнопки
    return current;                        // возвращаем состояние кнопки
    }
  }


